package net.minecraft.src;

public abstract class NRTSpline
{
	protected Vec3D position;
	protected NRTSpline nextNode;
	
	public NRTSpline()
	{
		position = Vec3D.createVectorHelper(0, 0, 0);
	}
	
	public void setPosition(Vec3D vec)
	{
		setPosition(vec.xCoord, vec.yCoord, vec.zCoord);
	}
	
	public void setPosition(double x, double y, double z)
	{
		position.xCoord = x;
		position.yCoord = y;
		position.zCoord = z;
	}
	
	public Vec3D getPosition()
	{
		return Vec3D.createVectorHelper(position.xCoord, position.yCoord, position.zCoord);
	}
	
	public void setNextSpline(NRTSpline next)
	{
		nextNode = next;
	}
	
	protected boolean containsFlag(int flag, int flags)
	{
		return (flags & flag) > 0;
	}
	
	public abstract Vec3D getInterpolatedPosition(double t);
	
	public abstract NRTEuler getHeading(double t, int flags);
	
	public NRTEuler getHeading(double t)
	{
		return getHeading(t, 0);
	}
}
